class Cruds {
  constructor(model) {
    this.model = model;
  }

  add(params={}) {
    return this.model.create( params );
  }

  async updateById(id, params = {}) {
    const record = await this.findById(id);
    if(!record)
      throw new Error('Object not found')
    return record.update(params)
  }

  findById( id ) {
    return this.model.findOne({
      where: {id: id},
    });
  }

  findAll( params= {} ) {
    return this.model.findAll({
      where: params,
    });
  }
  
  findOne( params= {}) {
    return this.model.findOne({
      where: params,
    });
  }

  async delete(id) {
    const record = await this.findById(id);
    if(!record)
      throw new Error('Object not found')
    return record.destroy();
  }
}
exports.Cruds = Cruds;

