const Joi = require('joi');

exports.getModelName = (model) => {
  if (!model) return '';
  return model.tableName;
};

const createJoiObject = (param, op) => {
  let joiObj;
  // console.log( ' => ',Object.getPrototypeOf(param.type).toString())
  switch (Object.getPrototypeOf(param.type).toString()) {
    case 'VARCHAR(undefined)':
      joiObj = Joi.string();
      break;
    case 'INTEGER':
      joiObj = Joi.number();
      break;
    case 'BOOLEAN':
      joiObj = Joi.boolean();
      break;
    default:
      joiObj = Joi.any();
  }
  switch (op) {
    case 'add':
      if(!param.allowNull && !param.primaryKey && !param._autoGenerated)
        joiObj = joiObj.required();
      break;
    case 'update':
      if(!param.allowNull)
        joiObj = joiObj.not('').not(null);
      break;
    default:
      break;
  }
  return joiObj;
};
exports.createSchema = (schema, op) => {
  const validationObj = {};
  Object.keys(schema).forEach((element) => {
    validationObj[element] = createJoiObject(schema[element], op);
  });
  return Joi.object(validationObj);
};
