exports.validationMiddleware = (schema, isGet = false) => (req, res, next) => {
  const body = isGet ? req.query : req.body;
  const { error } = schema.validate(body);
  if (error) {
    const err = new Error(error.message);
    err.code = 401;
    return next(err);
  }
  return next();
};
